<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

$attrubte_id = isset($_GET['edit']) ? sanitize_text_field(wp_unslash($_GET['edit'])) : '';
$_nonce      = isset( $_POST['amad_attr_nonce_field'] ) ? sanitize_text_field( wp_unslash( $_POST['amad_attr_nonce_field'] ) ) : 0;

if ( isset( $_POST['amad_attr_nonce_field'] ) && ! wp_verify_nonce( $_nonce, 'amad_attr_nonce_action' ) ) {
	die( 'Failed Security Check' );
}

if ( isset( $_POST['save_attribute'] ) ) {

	$attr_enb = isset( $_POST[ 'attr_enb-' . $attrubte_id ] ) ? sanitize_text_field(wp_unslash($_POST[ 'attr_enb-' . $attrubte_id ])) : '';
	update_option('attr_enb-' . $attrubte_id, $attr_enb );

	$regular_or_sale_price = isset( $_POST[ 'attr_regular_or_sale_price-' . $attrubte_id ] ) ? sanitize_text_field(wp_unslash($_POST[ 'attr_regular_or_sale_price-' . $attrubte_id ])) : 'regular_price';
	update_option('attr_regular_or_sale_price-' . $attrubte_id, $regular_or_sale_price );

	$fixed_or_percentage = isset( $_POST[ 'attr_fixed_or_percentage-' . $attrubte_id ] ) ? sanitize_text_field(wp_unslash($_POST[ 'attr_fixed_or_percentage-' . $attrubte_id ])) : '';
	update_option('attr_fixed_or_percentage-' . $attrubte_id, $fixed_or_percentage );

	$attr_amount = isset( $_POST[ 'attr_amount-' . $attrubte_id ] ) ? sanitize_text_field(wp_unslash($_POST[ 'attr_amount-' . $attrubte_id ])) : '';
	update_option('attr_amount-' . $attrubte_id, $attr_amount );
	
}
	$regular_or_sale_price = get_option('attr_regular_or_sale_price-' . $attrubte_id, 'sale_price') ;
	$fixed_or_percentage   = get_option('attr_fixed_or_percentage-' . $attrubte_id, '');
	$amount                = get_option('attr_amount-' . $attrubte_id, '');
	$attr_enb              = get_option('attr_enb-' . $attrubte_id, '');

	wp_nonce_field('amad_attr_nonce_action', 'amad_attr_nonce_field');

?>

		<tr class="form-field">
			<th scope="row" valign="top"><label style="font-size: 18px;" ><?php esc_html_e('Markup or Discount', 'addify-attribute-price-markup-discount'); ?></label></th>
			<td>
		</td>
		</tr>

		<tr class="form-field">
			<th scope="row" valign="top"><label for=""><?php esc_html_e('Enable', 'addify-attribute-price-markup-discount'); ?></label></th>
			<td>
				<input class="is_attr_enb_checbox" type="checkbox" name="attr_enb-<?php echo esc_attr($attrubte_id); ?>" value="1" <?php echo checked(esc_attr($attr_enb), '1'); ?>>
			</td>
		</tr>

		<tr class="form-field is_attr_enb">
			<th scope="row" valign="top"><label for=""><?php esc_html_e('Apply On', 'addify-attribute-price-markup-discount'); ?></label></th>
			<td>
				<input type="radio" name="attr_regular_or_sale_price-<?php echo esc_attr($attrubte_id); ?>" id="" value="sale_price" <?php echo checked( esc_attr($regular_or_sale_price), 'sale_price' ); ?> /><?php echo esc_html__( 'Sale Price', 'addify-attribute-price-markup-discount' ); ?>
				<input type="radio" name="attr_regular_or_sale_price-<?php echo esc_attr($attrubte_id); ?>" id="" value="regular_price" <?php echo checked( esc_attr($regular_or_sale_price), 'regular_price' ); ?> /><?php echo esc_html__( 'Regular Price', 'addify-attribute-price-markup-discount' ); ?>
				<p class="description"></p>
			</td>
		</tr>

		<tr class="form-field is_attr_enb">
			<th scope="row" valign="top"><label><?php echo esc_html__( 'Adjustment Type', 'addify-attribute-price-markup-discount' ); ?></label></th>
			<td>
				<select name="attr_fixed_or_percentage-<?php echo esc_attr($attrubte_id); ?>" id="">
					<option value="fixed_inc" <?php selected( 'fixed_inc', $fixed_or_percentage ); ?>><?php esc_html_e('Fixed Increase', 'addify-attribute-price-markup-discount'); ?></option>
					<option value="fixed_dec" <?php selected( 'fixed_dec', $fixed_or_percentage ); ?>><?php esc_html_e('Fixed Decrease', 'addify-attribute-price-markup-discount'); ?></option>
					<option value="percentage_inc" <?php selected( 'percentage_inc', $fixed_or_percentage ); ?>><?php esc_html_e('Percentage Increase', 'addify-attribute-price-markup-discount'); ?></option>
					<option value="percentage_dec" <?php selected( 'percentage_dec', $fixed_or_percentage ); ?>><?php esc_html_e('Percentage Decrease', 'addify-attribute-price-markup-discount'); ?></option>
					<option value="fixed_price" <?php selected( 'fixed_price', $fixed_or_percentage ); ?>><?php esc_html_e('Fixed Price', 'addify-attribute-price-markup-discount'); ?></option>
				</select>
				<p class="description"></p>
			</td>
		</tr>

		<tr class="form-field is_attr_enb">
			<th scope="row" valign="top"><label><?php echo esc_html__( 'Amount', 'addify-attribute-price-markup-discount' ); ?></label></th>
			<td>
				<input type="number" name="attr_amount-<?php echo esc_attr($attrubte_id); ?>" value="<?php echo esc_attr($amount); ?>">
			</td>
		</tr>

		<tr class="form-field form-field is_attr_enb">
			<th scope="row" valign="top"><label for=""><?php esc_html_e('Note', 'addify-attribute-price-markup-discount'); ?></label></th>
			<td>
				<h4><?php esc_html_e('Rule Priority Order', 'addify-attribute-price-markup-discount'); ?></h4>
				<ol>
					<li><?php esc_html_e('Rule Level Pricing', 'addify-attribute-price-markup-discount'); ?></li>
					<li><?php esc_html_e('Products > Attributes > Term Level Pricing', 'addify-attribute-price-markup-discount'); ?></li>
					<li><?php esc_html_e('Products > Attributes Level Pricing', 'addify-attribute-price-markup-discount'); ?></li>
				</ol>
			</td>
		</tr>

<?php
