<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}
$regular_or_sale_price = get_term_meta($term->term_id, 'regular_or_sale_price', true); 
$fixed_or_percentage   = get_term_meta($term->term_id, 'fixed_or_percentage', true);
$amount                = get_term_meta($term->term_id, 'amount', true);
$term_enb              = get_term_meta($term->term_id, 'term_enb', true);

wp_nonce_field('amad_term_nonce_action', 'amad_term_nonce_field');
?>
		<tr class="form-field">
			<th scope="row" valign="top"><label style="font-size: 18px;" ><?php esc_html_e('Markup or Discount', 'addify-attribute-price-markup-discount'); ?></label></th>
		</td>
		</tr>

		<tr class="form-field">
			<th scope="row" valign="top"><label for=""><?php esc_html_e('Enable', 'addify-attribute-price-markup-discount'); ?></label></th>
			<td>
				<input class="is_term_enb_checbox" type="checkbox" name="term_enb" value="1" <?php echo checked($term_enb, '1'); ?>>
			</td>
		</tr>

		<tr class="form-field is_term_enb">
			<th scope="row" valign="top"><label for=""><?php esc_html_e('Apply On', 'addify-attribute-price-markup-discount'); ?></label></th>
			<td>
				<input type="radio" name="regular_or_sale_price" id="" value="regular_price" <?php echo checked( $regular_or_sale_price, 'regular_price' ); ?> /><?php echo esc_html__( 'Regular Price', 'addify-attribute-price-markup-discount' ); ?>
				<input type="radio" name="regular_or_sale_price" id="" value="sale_price" <?php echo checked( $regular_or_sale_price, 'sale_price' ); ?> /><?php echo esc_html__( 'Sale Price', 'addify-attribute-price-markup-discount' ); ?>
				<p class="description"></p>
			</td>
		</tr>

		<tr class="form-field is_term_enb">
			<th scope="row" valign="top"><label><?php echo esc_html__( 'Adjustment Type', 'addify-attribute-price-markup-discount' ); ?></label></th>
			<td>
				<select name="fixed_or_percentage" id="">
					<option value="fixed_inc" <?php selected( 'fixed_inc', $fixed_or_percentage ); ?>><?php esc_html_e('Fixed Increase', 'addify-attribute-price-markup-discount'); ?></option>
					<option value="fixed_dec" <?php selected( 'fixed_dec', $fixed_or_percentage ); ?>><?php esc_html_e('Fixed Decrease', 'addify-attribute-price-markup-discount'); ?></option>
					<option value="percentage_inc" <?php selected( 'percentage_inc', $fixed_or_percentage ); ?>><?php esc_html_e('Percentage Increase', 'addify-attribute-price-markup-discount'); ?></option>
					<option value="percentage_dec" <?php selected( 'percentage_dec', $fixed_or_percentage ); ?>><?php esc_html_e('Percentage Decrease', 'addify-attribute-price-markup-discount'); ?></option>
					<option value="fixed_price" <?php selected( 'fixed_price', $fixed_or_percentage ); ?>><?php esc_html_e('Fixed Price', 'addify-attribute-price-markup-discount'); ?></option>
				</select>
				<p class="description"></p>
			</td>
		</tr>

		<tr class="form-field is_term_enb">
			<th scope="row" valign="top"><label><?php echo esc_html__( 'Amount', 'addify-attribute-price-markup-discount' ); ?></label></th>
			<td>
				<input type="number" name="amount" value="<?php echo esc_attr($amount); ?>">
			</td>
		</tr>

		<tr class="form-field form-field is_term_enb">
			<th scope="row" valign="top"><label for=""><?php esc_html_e('Note', 'addify-attribute-price-markup-discount'); ?></label></th>
			<td>
				<h4><?php esc_html_e('Rule Priority Order', 'addify-attribute-price-markup-discount'); ?></h4>
				<ol>
					<li><?php esc_html_e('Rule Level Pricing', 'addify-attribute-price-markup-discount'); ?></li>
					<li><?php esc_html_e('Products > Attributes > Term Level Pricing', 'addify-attribute-price-markup-discount'); ?></li>
					<li><?php esc_html_e('Products > Attributes Level Pricing', 'addify-attribute-price-markup-discount'); ?></li>
				</ol>
			</td>
		</tr>



	