<?php
class Afamad_Ajax_Controller {
	public $front_variation_data = array();
	public function __construct() {
		add_action( 'wp_ajax_afamad_variation_any_case_ajax', array( $this, 'afamad_variation_any_case_ajax' ) );
		add_action( 'wp_ajax_nopriv_afamad_variation_any_case_ajax', array( $this, 'afamad_variation_any_case_ajax' ) );
		add_action( 'woocommerce_before_calculate_totals', array( $this, 'afamad_update_cart_price' ), 99, 1 );
		add_filter( 'woocommerce_cart_item_price', array( $this, 'afamad_mini_cart_update' ), 10, 3);

		if (!is_admin()) {
			add_filter( 'woocommerce_variable_price_html', array( $this, 'afamad_price_range_for_variable_product' ), 10, 2 );
		}
	}
	public function tax_adding_too_new_price( $product, $price ) {
		$woocommerce_calc_taxes         = get_option('woocommerce_calc_taxes');
		$woocommerce_prices_include_tax = get_option('woocommerce_prices_include_tax');
		$woocommerce_tax_display_shop   = get_option('woocommerce_tax_display_shop');
		$woocommerce_tax_display_cart   = get_option('woocommerce_tax_display_cart');

		if ('no' == $woocommerce_calc_taxes) {
			return $price;
		}

		if ( is_cart() || is_checkout() ) {
			if ('excl' == $woocommerce_tax_display_cart) {
				$price = wc_get_price_excluding_tax( $product, array(
					'qty'   => 1,
					'price' => $price,
				) );

			} elseif ('incl' == $woocommerce_tax_display_cart) {
				$price = wc_get_price_including_tax( $product, array(
					'qty'   => 1,
					'price' => $price,
				) );

			} else {
				return $price;
			}
		} elseif ('excl' == $woocommerce_tax_display_shop) {
				$price = wc_get_price_excluding_tax( $product, array(
					'qty'   => 1,
					'price' => $price,
				) );


		} elseif ('incl' == $woocommerce_tax_display_shop) {
			$price = wc_get_price_including_tax( $product, array(
				'qty'   => 1,
				'price' => $price,
			) );

		} else {
			return $price;
		}

		return $price;
	}

	public function af_amad_generate_combinations( $arrays ) {
		$result = array( array() );
		foreach ( $arrays as $property => $property_values ) {
			$temp = array();
			foreach ( $result as $item ) {
				foreach ( $property_values as $value ) {
					$temp[] = array_merge( $item, array( $property => $value ) );
				}
			}
			$result = $temp;
		}
		return $result;
	}
	public function amad_array_exists( $needle, $haystack ) {
		foreach ($haystack as $item) {
			if (array_intersect_assoc($needle, $item) === $needle) {
				return true;
			}
		}
		return false;
	}
	public function afamad_price_range_for_variable_product( $price, $product ) {
		if ( $product->is_type( 'variable' ) ) {

			// ---------------------all combinations.
			$attributes            = $product->get_attributes();
			$attribute_terms       = array();
			$all_prices            = array();
			$varaition_already_set = array();

			$find_empty_variation = false;
			foreach ( $attributes as $attribute_name => $attribute ) {
				if ( $attribute->is_taxonomy() ) {
					$terms                              = wc_get_product_terms( $product->get_id(), $attribute->get_name(), array( 'fields' => 'slugs' ) );
					$attribute_terms[ $attribute_name ] = $terms;

				} else {
					$attribute_terms[ $attribute_name ] = $attribute->get_options();
				}
			}
			$all_combinations = $this->af_amad_generate_combinations( $attribute_terms );
		}

		// ------------------------- hook combniations.
		$afamad_variations = $product->get_available_variations();
		foreach ( $afamad_variations as $afamad_variation_data ) {
			
			$variation_id = $afamad_variation_data['variation_id'];
			$product      = new WC_Product_Variation( $variation_id );

			$item_variation_data = array();
			//remooving arribute text.
			foreach ( $afamad_variation_data['attributes'] as $key => $value ) {
				if ( strpos( $key, 'attribute_pa_' ) === 0 ) {
					$new_key                         = str_replace( 'attribute_', '', $key );
					$item_variation_data[ $new_key ] = $value;
				}
			}

			if (empty(array_filter($item_variation_data, fn( $value ) => !empty($value)))) {
				$find_empty_variation = true;
				foreach ($all_combinations as $combination) {
					$result = $this->amad_array_exists($combination, $varaition_already_set);
					if ($result) {
						continue;
					}
					$global_rules_result = $this->global_rules_ajax_result($product, $combination);
					$term_rules_result   = $this->afamad_check_term_ajax_settings($product, $combination);
					$attr_rules_result   = $this->afamad_check_attr_settings($product, $combination);
	
					if (is_array($global_rules_result)) {
						$price = $global_rules_result[1] > 0 ? $global_rules_result[1] :0;
	
					} elseif (is_array($term_rules_result) && isset($term_rules_result[1])) {
						$price = $term_rules_result[1] > 0 ? $term_rules_result[1] : 0;
	
					} elseif (is_array($attr_rules_result) ) {
						$price = $attr_rules_result[1] > 0 ? $attr_rules_result[1] : 0;

					} else {

						$price = $product->get_sale_price();
						if ( ( !$product->is_on_sale() || empty($product->get_sale_price()) ) ) {
							$price = $product->get_regular_price();
							
						}
					}
					$price        = $this->tax_adding_too_new_price($product, $price);
					$all_prices[] = $price;
				}
				
			} else {
				if ($find_empty_variation) {
					continue;
				}
				$varaition_already_set[] = $item_variation_data;
				$global_rules_result     = $this->global_rules_ajax_result($product, $item_variation_data);
				$term_rules_result       = $this->afamad_check_term_ajax_settings($product, $item_variation_data);
				$attr_rules_result       = $this->afamad_check_attr_settings($product, $item_variation_data);

				if (is_array($global_rules_result)) {
					$price = $global_rules_result[1] > 0 ? $global_rules_result[1] :0;

				} elseif (is_array($term_rules_result) && isset($term_rules_result[1])) {
					$price = $term_rules_result[1] > 0 ? $term_rules_result[1] : 0;

				} elseif (is_array($attr_rules_result) ) {
					$price = $attr_rules_result[1] > 0 ? $attr_rules_result[1] : 0;
					// $price = wc_price($price);
				} else {
					$price = $product->get_sale_price();
					if ( ( !$product->is_on_sale() || empty($product->get_sale_price()) ) ) {
						$price = $product->get_regular_price();
					}
				}
				$price        = $this->tax_adding_too_new_price($product, $price);
				$all_prices[] = $price;
			}
		}

		if (min($all_prices) != max($all_prices)) {
			$price = wc_price( min($all_prices) ) . ' - ' . wc_price( max($all_prices) );
		} else {
			$price = wc_price( min($all_prices) ) ;
		}
		return $price;
	}
	public function afamad_mini_cart_update( $price, $cart_item, $cart_item_key ) {
		$item_variation_data = array();
		foreach ( $cart_item as $cart_item_key => $cart_items ) {
			if ( isset( $cart_item['variation_id'] ) ) {

				foreach ( $cart_item['variation'] as $key => $value ) {
					if ( strpos( $key, 'attribute_pa_' ) === 0 ) {
						$new_key                         = str_replace( 'attribute_', '', $key );
						$item_variation_data[ $new_key ] = $value;
					}
				}

				$variation_id        = $cart_item['variation_id'];
				$product             = new WC_Product_Variation( $variation_id );
				$global_rules_result = $this->global_rules_ajax_result($product, $item_variation_data);
				$term_rules_result   = $this->afamad_check_term_ajax_settings($product, $item_variation_data);
				$attr_rules_result   = $this->afamad_check_attr_settings($product, $item_variation_data);
				
				if (is_array($global_rules_result)) {
					$price = $global_rules_result[1] > 0 ? $global_rules_result[1] :0;
					$price = $this->tax_adding_too_new_price($product, $price);
					$price = wc_price($price); // Format the price

				} elseif (is_array($term_rules_result) && isset($term_rules_result[1])) {
					$price = $term_rules_result[1] > 0 ? $term_rules_result[1] : 0;
					$price = $this->tax_adding_too_new_price($product, $price);
					$price = wc_price($price);

				} elseif (is_array($attr_rules_result) ) {
					$price = $attr_rules_result[1] > 0 ? $attr_rules_result[1] : 0;
					$price = $this->tax_adding_too_new_price($product, $price);
					$price = wc_price($price);
				}
			}
		}
	
		return $price;
	}
	public function afamad_variation_any_case_ajax() {
		$nonce = isset( $_POST['nonce'] ) ? sanitize_text_field( wp_unslash( $_POST['nonce'] ) ) : 0;
		if ( ! wp_verify_nonce( $nonce, 'afamad-front-ajax-nonce' ) ) {
		die( esc_html__('Failed ajax security check!', 'addify-attribute-price-markup-discount') );
		}

		WC()->session->__unset( 'front_variation_data' );
		if (isset($_POST['formData']) && !empty($_POST['formData'])) {
			parse_str(sanitize_meta('', wp_unslash($_POST['formData']), ''), $variation_data);

		}
		if (!isset($variation_data) || !is_array($variation_data) || empty($variation_data)) {
			return;
		}

		foreach ( $variation_data as $key => $value ) {
			if ( strpos( $key, 'attribute_pa_' ) === 0 ) {
				$new_key                                = str_replace( 'attribute_', '', $key );
				$this->front_variation_data[ $new_key ] = $value;
			}
		}

		// if (!isset($this->front_variation_data['pa_size'])) {
		//  $this->front_variation_data['pa_size'] = '';
		// }

		WC()->session->set( 'front_variation_data', $this->front_variation_data);
		$product = new WC_Product_Variation( $variation_data['variation_id'] );

		$global_rules_result = $this->global_rules_ajax_result($product);
		$term_rules_result   = $this->afamad_check_term_ajax_settings($product);
		$attr_rules_result   = $this->afamad_check_attr_settings($product);


		if (is_array($global_rules_result)) {
			$price = $global_rules_result[1];
			if ($price<0) {
				$price =0;
			}
			if ($price >= $product->get_regular_price()) {
				$price      = $this->tax_adding_too_new_price($product, $price);
				$price_html = '</span>' . wc_price($price) . '</span>';
				wp_send_json( $price_html);

			} elseif ($price != $product->get_regular_price()) {
				wp_send_json(  '<del>' . wc_price($product->get_regular_price()) . '</del><br></span>' . wc_price($price) . '</del>');
			}
		} elseif (is_array($term_rules_result) && isset($term_rules_result[1])) {
			$price = $term_rules_result[1] > 0 ? $term_rules_result[1] : 0;
			
			if ($price >= $product->get_regular_price()) {
				$price      = $this->tax_adding_too_new_price($product, $price);
				$price_html = '</span>' . wc_price($price) . '</span>';
				wp_send_json( $price_html);

			} elseif ($price != $product->get_regular_price()) {
				$price = $this->tax_adding_too_new_price($product, $price);
				wp_send_json(  '<del>' . wc_price($product->get_regular_price()) . '</del><br></span>' . wc_price($price) . '</del>');
			}

		} elseif (is_array($attr_rules_result) ) {
			$price = $attr_rules_result[1] > 0 ? $attr_rules_result[1] : 0;
			if ($price >= $product->get_regular_price()) {
				$price      = $this->tax_adding_too_new_price($product, $price);
				$price_html = '</span>' . wc_price($price) . '</span>';
				wp_send_json( $price_html);

			} elseif ($price != $product->get_regular_price()) {
				$price = $this->tax_adding_too_new_price($product, $price);
				wp_send_json(  '<del>' . wc_price($product->get_regular_price()) . '</del><br></span>' . wc_price($price) . '</del>');
			}
		} elseif (!$product->is_on_sale() || empty($product->get_sale_price()) ) {
				wp_send_json(  '<span>' . wc_price($product->get_regular_price()) . '</span>');

		} else {
			wp_send_json(  '<del>' . wc_price($product->get_regular_price()) . '</del><br></span>' . wc_price($product->get_sale_price()) . '</del>');
		}
	}
	public function afamad_cal_price( $price, $amount, $fixed_or_percentage, $price_for_percentage ) {
		switch ( $fixed_or_percentage ) {
			case 'fixed_inc':
				$price = floatval( $price ) + floatval( $amount );
				break;
			case 'fixed_dec':
				$price = floatval( $price ) - floatval( $amount );
				break;
			case 'percentage_inc':
				$price = floatval( $price ) + ( floatval( $price_for_percentage ) * floatval( $amount ) / 100.0 );
				break;
			case 'percentage_dec':
				$price = floatval( $price ) - ( floatval( $price_for_percentage ) * floatval( $amount ) / 100.0 );
				break;
			case 'fixed_price':
				$price = floatval( $amount );
				break;
		}

		return $price;
	}
	public function global_rules_ajax_result( $product, $item_variation_data = array() ) {

		$product_id      = $product->get_id();
		$afamad_rules    = $this->afamad_get_all_rules();
		$is_rule_applied = false;

		foreach ($afamad_rules as $rule_id) {

			$rule_enb     = get_post_meta( $rule_id, 'rule_enb', true );
			$rule_date    = get_post_meta( $rule_id, 'rule_date', true);
			$user_roles   = (array) get_post_meta( $rule_id, 'user_roles', true  );
			$product_type = get_post_meta( $rule_id, 'product_type', true );
			$sel_products = get_post_meta( $rule_id, 'select_products', true );
			$sel_cat      = get_post_meta( $rule_id, 'select_pro_cat', true );
			$all_products = get_post_meta( $rule_id, 'af_apply_on_sll_products', true );
			$user         = wp_get_current_user();
			$roles        = ( array ) $user->roles;

			if (empty($rule_enb)) {
				continue;
			}

			if (!empty($rule_date[0]) && !empty($rule_date[1])) {
				$start_date   = strtotime($rule_date[0]);
				$end_date     = strtotime($rule_date[1]);
				$current_date = strtotime(gmdate('Y-m-d'));

				if (!( $current_date >= $start_date && $current_date <= $end_date )) {
					continue;
				}
			}

			if (!empty($rule_date[0]) && empty($rule_date[1])) {
				$start_date   = strtotime($rule_date[0]);
				$current_date = strtotime(gmdate('Y-m-d'));
				if (!( $current_date >= $start_date )) {
					continue;
				}
			}

			if (empty($rule_date[0]) && !empty($rule_date[1])) {
				$end_date     = strtotime($rule_date[1]);
				$current_date = strtotime(gmdate('Y-m-d'));
				if (!( $current_date <= $end_date )) {
					continue;
				}
			}


			if (!empty($user_roles)) {
				if (is_user_logged_in()) {
					if (!in_array($roles[0], $user_roles)) {
						continue;
					}

				} elseif (!in_array('guest', $user_roles)) {
						continue;
				}
			}
			// product restrict in rules.
			if (!$all_products) {
				$final_sel_products = array();
				foreach ($sel_products as $selected_product_id) {
					$afamad_product = wc_get_product($selected_product_id);
					if ('variable' == $afamad_product->get_type()) {
						$final_sel_products = array_merge(array( $selected_product_id ), $afamad_product->get_children());
					} else {
						$final_sel_products [] = $selected_product_id;
					}
				}

				//product restriction.
				$sel_products = $final_sel_products;
				switch ($product_type) {
					case 'enclude':
						if ( in_array($product_id, $sel_products) ) {
							$is_rule_applied = true;
						}
						break;
					case 'exclude':
						if ( in_array($product_id, $sel_products) ) {
							return false;
						} else {
							$is_rule_applied = true;
						}
						break;               
				} 

				// category restriction
				$afamad_product_id_for_cat = ( 0 == wp_get_post_parent_id( $product_id ) ) ? $product_id : wp_get_post_parent_id( $product_id );
				$product_categories        = wp_get_post_terms( $afamad_product_id_for_cat, 'product_cat', array( 'fields' => 'ids' ) );

				if (empty($sel_cat) && empty($sel_products)) {
					$is_rule_applied = true;
				}

				if (!empty($sel_cat)) {
					switch ($product_type) {
						case 'enclude':
							if (  ! empty( array_intersect( $product_categories, $sel_cat ) ) ) {
								$is_rule_applied = true;
							}
							break;
						case 'exclude':
							if ( ! empty( array_intersect( $product_categories, $sel_cat ) ) ) {
								return false;

							} else {
								$is_rule_applied = true;
							}
							break;               
					} 
				}
			}

			if (!$is_rule_applied && !$all_products ) {
				return false;
			}

			// -----------------------------------------------------------------------table rule check-------------------------------------------------------------------------------------.

			$product_parent_id = $product->get_parent_id();
			if ($product_parent_id) {
				$variation_id = $product->get_id();
				if (!empty($item_variation_data)) {
					$product_attributes = $item_variation_data;
				} else {
					$product_attributes = WC()->session->get( 'front_variation_data' );
				}
				$af_amad_rule_settings = (array) get_post_meta( $rule_id, 'af_amad_rule_settings', true );
				$af_select_attribute   = (array) get_post_meta( $rule_id, 'af_select_attribute', true );
				$af_select_attribute   = isset($af_select_attribute) ? $af_select_attribute : array();

				foreach ( $af_amad_rule_settings as $key => $ruleset_data ) {
					$term_for_rule = array();

					foreach ( $af_select_attribute as $key =>$get_child_post_id ) {
						
						$let_total_match_attr = 0;
						foreach ($get_child_post_id as $child_keys => $value) { 
						
							if (!is_int($child_keys) || ! is_array($value) || ! isset($value['attribute']) || empty($value['attribute']) ) {
								continue;
							}

							$terms     = isset($value['term']) ? $value['term'] : array();
							$attribute = 'pa_' . $value['attribute'];

							if (empty($terms)) {
								$term_for_rule[ $key ][ $attribute ][] = array();
							}

							foreach ($terms as $current_term_id) {
								$attribute                             = 'pa_' . $value['attribute'];
								$term_for_rule[ $key ][ $attribute ][] = get_term( $current_term_id )->slug;
							}   
						}
					}
				}

				$rule_match = false;

				foreach ($term_for_rule as $key => $attributes) {
					// if (count($product_attributes) != count($attributes) || array_diff(array_keys($product_attributes), array_keys($attributes))) {
					//  continue;
					// }
					
					$all_match = true;
					foreach ($product_attributes as $attr_key => $attr_value) {
						$attr_value = strtolower($attr_value);

						if (empty($attributes[ $attr_key ][0])) {
							continue;
						}

						if (!isset($attributes[ $attr_key ]) || !in_array($attr_value, array_map('strtolower', $attributes[ $attr_key ]))) {
							$all_match = false;
							break;
						}
					}
					if ($all_match) {
						$rule_match       = true;
						$matched_group_id = $key; 
					}
				}

				if ($rule_match) {
					$group_settings  = $af_select_attribute[ $matched_group_id ];
					$regular_sale    = isset($group_settings['rule_apply_on_regular_or_sale_price']) ? $group_settings['rule_apply_on_regular_or_sale_price'] : '';
					$markup_markdown = isset($group_settings['markup_markdown']) ? $group_settings['markup_markdown'] : 'markup';
					$rule_amount     = isset($group_settings['amount']) ? $group_settings['amount'] : '';
					$variation       = wc_get_product( $product_id );

					if ('regular' == $regular_sale) {
						$price = $product->get_regular_price();
						$price = $this->afamad_cal_price($price, $rule_amount, $markup_markdown, $price);
						return array( $rule_match, $price );

					} else {
						$price = $product->get_sale_price();
						if ('sale' == $regular_sale && ( !$product->is_on_sale() || empty($product->get_sale_price()) ) ) {
							$price = $product->get_regular_price();
						}
						$price      = $this->afamad_cal_price($price, $rule_amount, $markup_markdown, $price);
						$price_html = $price;

						return array( $rule_match, $price_html );
					}
				}
				
			}
			// --------table rule check END.
		}
	}
	public function afamad_check_term_ajax_settings( $product, $item_variation_data = array() ) {
		$product_parent_id = $product->get_parent_id();
		if ($product_parent_id && current_action() != 'woocommerce_product_get_regular_price' && current_action() != 'woocommerce_product_get_price') {

			$total_amount     = 0;
			$first_term_match = false;
			if (!empty($item_variation_data)) {
				$attributes = $item_variation_data;
			} else {
				$attributes = WC()->session->get( 'front_variation_data' );
			}

			foreach ($attributes as $taxonomy => $term_slug) {
				
				$is_rule_applied = false;
				$taxonomy        = str_replace('attribute_', '', $taxonomy);
				$term            = get_term_by('slug', $term_slug, $taxonomy);

				if ($term) {
					$regular_or_sale_price = get_term_meta($term->term_id, 'regular_or_sale_price', true); 
					$fixed_or_percentage   = get_term_meta($term->term_id, 'fixed_or_percentage', true);
					$amount                = get_term_meta($term->term_id, 'amount', true);
					$term_enb              = get_term_meta($term->term_id, 'term_enb', true);
				}
				
				if (empty($term_enb)) {
					$is_rule_applied = false;
					continue;
				}

				if (!empty($regular_or_sale_price) && !empty($fixed_or_percentage) && !empty($amount) ) {
					$is_rule_applied = true;
				}

				if ($is_rule_applied) {
					if ( 'regular_price' == $regular_or_sale_price ) {
						$price = $product->get_regular_price();
						if ($first_term_match) {
							$amount           = $this->afamad_cal_price(0, $amount, $fixed_or_percentage, $price);
							$total_amount    += intval($amount);
							$first_term_match = true;

						} else {
							$amount           = $this->afamad_cal_price($price, $amount, $fixed_or_percentage, $price);
							$total_amount    += intval($amount);
							$first_term_match = true;
						}

					} else {
						if ('sale' == $regular_or_sale_price && ( !$product->is_on_sale() || empty($product->get_sale_price()) ) ) {
							$price = $product->get_regular_price();
	
						} else {
							$price = $product->get_regular_price();
						}
						if ($first_term_match) {
							$amount           = $this->afamad_cal_price(0, $amount, $fixed_or_percentage, $price);
							$total_amount    += intval($amount);
							$first_term_match = true;

						} else {
							$amount           = $this->afamad_cal_price($price, $amount, $fixed_or_percentage, $price);
							$total_amount    += intval($amount);
							$first_term_match = true;
						}
					}
				} 
			}

			if ($first_term_match) {
				return array( $is_rule_applied, $total_amount );
			} else {
				return false;
			}
		}
	}

	public function afamad_check_attr_settings( $product, $item_variation_data = array() ) {

		$product_id         = $product->get_id();
		$attribute_ids      = array();
		$total_amount       = 0;
		$first_attr_matched = false;
		$is_rule_applied    = false;

		if ( $product instanceof WC_Product_Variation ) {
				$parent_id      = $product->get_parent_id();
				$parent_product = wc_get_product( $parent_id );

			if (!$parent_product) {
				return;
			}
				$attributes = $parent_product->get_attributes();
			

		
			foreach ( $product->get_variation_attributes() as $taxonomy => $value ) {
				$taxonomy = str_replace( 'attribute_', '', $taxonomy );
		
				if ( isset( $attributes[ $taxonomy ] ) ) {
					$attribute = $attributes[ $taxonomy ];

					$attribute_ids[] = $attribute->get_id();
				}
			}
		} else {
			$attributes = $product->get_attributes();
			foreach ( $attributes as $attribute ) {
				if ( $attribute->is_taxonomy() ) {
					$attribute_ids[] = $attribute->get_id();
				}
			}
		}

		foreach ( $attribute_ids as $attribute ) {
				$attribute_id          = $attribute;
				$regular_or_sale_price = get_option('attr_regular_or_sale_price-' . $attribute_id, 'sale_price');
				$fixed_or_percentage   = get_option('attr_fixed_or_percentage-' . $attribute_id, '');
				$amount                = get_option('attr_amount-' . $attribute_id, '');
				$attr_enb              = get_option('attr_enb-' . $attribute_id, '');
				$is_rule_applied       = true;

			if (empty($amount) || empty($fixed_or_percentage) || empty($regular_or_sale_price) || empty($attr_enb)) {
				$is_rule_applied = false; 
				continue;
			}

			if ($is_rule_applied) {
				if ('regular_price' == $regular_or_sale_price) {
					$price = $product->get_regular_price();
					if ($first_attr_matched) {
						$amount             = $this->afamad_cal_price(0, $amount, $fixed_or_percentage, $price);
						$total_amount      += intval($amount);
						$first_attr_matched = true;

					} else {
						$amount             = $this->afamad_cal_price($price, $amount, $fixed_or_percentage, $price);
						$total_amount      += intval($amount);
						$first_attr_matched = true;
					}

				} else {
					if ('sale' == $regular_or_sale_price && ( !$product->is_on_sale() || empty($product->get_sale_price()) ) ) {
						$price = $product->get_regular_price();

					} else {
						$price = $product->get_regular_price();
					}
					if ($first_attr_matched) {
						$amount             = $this->afamad_cal_price(0, $amount, $fixed_or_percentage, $price);
						$total_amount      += intval($amount);
						$first_attr_matched = true;

					} else {
						$amount             = $this->afamad_cal_price($price, $amount, $fixed_or_percentage, $price);
						$total_amount      += intval($amount);
						$first_attr_matched = true;
					}
				}
			}
		}

		if (!empty($total_amount)) {
			if (!empty($total_amount) && 0 == $total_amount) {
				$is_rule_applied = false;
			}
			return array( $is_rule_applied, $total_amount );

		} else {
			return false;
		}
	}

	public function afamad_update_cart_price( $cart ) {
		if ( is_admin() && ! defined( 'DOING_AJAX' ) ) {
			return;
		}

		// Loop through the cart items
		$item_variation_data = array();
		foreach ( $cart->get_cart() as $cart_item_key => $cart_item ) {
			if ( isset( $cart_item['variation_id'] ) ) {

				foreach ( $cart_item['variation'] as $key => $value ) {
					if ( strpos( $key, 'attribute_pa_' ) === 0 ) {
						$new_key                         = str_replace( 'attribute_', '', $key );
						$item_variation_data[ $new_key ] = $value;
					}
				}

				$variation_id        = $cart_item['variation_id'];
				$product             = new WC_Product_Variation( $variation_id );
				$global_rules_result = $this->global_rules_ajax_result($product, $item_variation_data);
				$term_rules_result   = $this->afamad_check_term_ajax_settings($product, $item_variation_data);
				$attr_rules_result   = $this->afamad_check_attr_settings($product, $item_variation_data);
				
				if (is_array($global_rules_result)) {
					$price = $global_rules_result[1] > 0 ? $global_rules_result[1] :0;
					$cart_item['data']->set_price( $price );

				} elseif (is_array($term_rules_result) && isset($term_rules_result[1])) {
					$price = $term_rules_result[1] > 0 ? $term_rules_result[1] : 0;
					$cart_item['data']->set_price( $price );

				} elseif (is_array($attr_rules_result) ) {
					$price = $attr_rules_result[1] > 0 ? $attr_rules_result[1] : 0;
					$cart_item['data']->set_price( $price );
				}
			}
		}
	}

	public function afamad_get_all_rules() {
		return get_posts(
			array(
				'post_type'      => 'addify_amad_cpt',
				'posts_per_page' => -1,
				'post_status'    => 'publish',
				'fields'         => 'ids',
				'orderby'        => 'menu_order',
				'order'          => 'ASC',
			)
		);
	}
}
new Afamad_Ajax_Controller();
