<?php 

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

if (!class_exists('Addify_Amad_Front')) {
	class Addify_Amad_Front {
		public function __construct() {
			add_action( 'wp_enqueue_scripts', array( $this, 'af_amad_front_enqueue_css_js' ) , 10 );
		}
		public function af_amad_front_enqueue_css_js() {
			$product = wc_get_product( get_the_ID() );
			// Get product attributes
			$product_attr_name_for_js = array();

			if ($product && is_product()) {
				$attributes = $product->get_attributes();
				if ( ! empty( $attributes ) ) {
					foreach ( $attributes as $attribute_name => $attribute ) {
						$product_attr_name_for_js[] = $attribute_name;
					}
	
				} else {
					$product_attr_name_for_js = false;
				}
			}

			$afamad_data = array(
				'admin_url'                => admin_url( 'admin-ajax.php' ),
				'nonce'                    => wp_create_nonce( 'afamad-front-ajax-nonce' ),
				'product_attr_name_for_js' => $product_attr_name_for_js,

			);
			if (amad_is_need_to_include_ajax_file()) {
				wp_enqueue_script( 'afamad-js-front', ADDIFY_AMAD_URL . 'assets/js/front.js', array( 'jquery' ), '1.0', false );
				wp_localize_script( 'afamad-js-front', 'afamad_php_front_vars', $afamad_data );
			}
		}
	}

new Addify_Amad_Front();
}
