<?php 
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}
function afamad_get_all_rules() {
	return get_posts(
		array(
			'post_type'      => 'addify_amad_cpt',
			'posts_per_page' => -1,
			'post_status'    => 'publish',
			'fields'         => 'ids',
			'orderby'        => 'menu_order',
			'order'          => 'ASC',
		)
	);
}
function amad_is_need_to_include_ajax_file() {
	$afamad_rules       = afamad_get_all_rules();
	$flag_add_ajax_file = false;

	if (!empty($afamad_rules)) {
		foreach ($afamad_rules as $rule_id) {
			$rule_enb = get_post_meta( $rule_id, 'rule_enb', true );
			if ($rule_enb) {
				$flag_add_ajax_file = true;
				break;
			}
		}

	}
	if (!$flag_add_ajax_file) {

		$attribute_taxonomies = wc_get_attribute_taxonomies();
		foreach ($attribute_taxonomies as $attribute) {
			$taxonomy = wc_attribute_taxonomy_name($attribute->attribute_name);

			if (taxonomy_exists($taxonomy)) {
				$terms = get_terms(array(
					'taxonomy'   => $taxonomy,
					'hide_empty' => false, // Set to true if you want only terms in use
				));
				foreach ($terms as $term) {
					$term->term_id;
					$term_enb = get_term_meta($term->term_id, 'term_enb', true);
					if ($term_enb) {
						$flag_add_ajax_file = true;
						break 2;
					}

				}
			}
		}
	}
	
	if (!$flag_add_ajax_file) {
		$attributes = wc_get_attribute_taxonomies();
		if ( ! empty( $attributes ) ) {
			foreach ( $attributes as $attribute ) {
				$attr_enb = get_option('attr_enb-' . $attribute->attribute_id, '');
				if ($attr_enb) {
					$flag_add_ajax_file = true;
					break;
				}
			}
		}
	}

	if ($flag_add_ajax_file) {
		return true;
	} else {
		return false;
	}
}
