<?php

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

$user_roles = (array) get_post_meta( get_the_ID(), 'user_roles', true  );

$product_type =  get_post_meta( get_the_ID(), 'product_type', true );
$product_type = !empty($product_type) ? $product_type : 'enclude';

$on_all_prodycts =  get_post_meta( get_the_ID(), 'af_apply_on_sll_products', true );

$sel_products =  get_post_meta( get_the_ID(), 'select_products', true );
$sel_products = is_array($sel_products) ? $sel_products : array();

$sel_cat =  get_post_meta( get_the_ID(), 'select_pro_cat', true );
$sel_cat = is_array($sel_cat) ? $sel_cat : array();

$select_attr =  get_post_meta( get_the_ID(), 'select_pro_attr', true );
$select_attr = is_array($select_attr) ? $select_attr : array();

$sel_terms   =  get_post_meta( get_the_ID(), 'select_pro_terms', true );
$sel_terms   = is_array($sel_terms) ? $sel_terms : array();
$product_cat = get_terms( 'product_cat');

?>
<div class="afamad-main_container">
	<table class="addify-table-optoin">
	<tr class="addify-option-field">
			<th>
				<div class="option-head">
					<h3>
						<?php echo esc_html__( 'Select User Roles', 'addify-attribute-price-markup-discount' ); ?>
					</h3>
				</div>
			</th>
			<td>
			<div class="">
				<select  name="user_roles[]" id="user_roles" data-placeholder="Select Roles..." multiple>
			<?php
				global $wp_roles;
				$roles = $wp_roles->get_names();
			if (!array_key_exists('guest', $roles)) {
				$roles['guest'] = 'Guest';
			}

			foreach ( $roles as $key => $value ) {
				?>
						<option 
						<?php
						if ( ! empty( $user_roles ) && in_array( (string) $key, $user_roles, true ) ) {
							echo 'selected'; }
						?>
						value="<?php echo esc_attr( $key ); ?>"><?php echo esc_attr( $value ); ?></option>

					<?php } ?>
				</select>
			</div>
				<p><?php echo esc_html__( 'Leave empty to apply on all roles', 'addify-attribute-price-markup-discount' ); ?></p>
			</td>
		</tr>
		<tr class="addify-option-field" style="border-bottom: none;">
			<th>
				<div class="option-head">
					<h3>
						<?php echo esc_html__( 'Apply on Entire Catalog', 'addify-attribute-price-markup-discount' ); ?>
					</h3>
				</div>
			</th>
			<td>
				<input type="checkbox" name="af_apply_on_sll_products" class='af_apply_on_sll_products' value="1"<?php echo checked($on_all_prodycts, '1'); ?>>
			</td>
			
		</tr>
			<tr class="addify-option-field enable_field" style="border-bottom: none;">
				<th>
					<div class="option-head">
						<h3>
							<?php echo esc_html__( 'Products', 'addify-attribute-price-markup-discount' ); ?>
						</h3>
					</div>
				</th>
				<td>
				<input type="radio" name="product_type" id="" value="enclude" <?php echo checked( $product_type, 'enclude'); ?> /><?php echo esc_html__( 'Include', 'addify-attribute-price-markup-discount' ); ?>
				<input type="radio" name="product_type" id="" value="exclude" <?php echo checked( $product_type, 'exclude' ); ?> /><?php echo esc_html__( 'Exclude', 'addify-attribute-price-markup-discount' ); ?>
					
				</td>
			</tr>
	
			<tr class="addify-option-field enable_field">
				<th>
					<div class="option-head">
						<h3>
							<?php echo esc_html__( 'Select Product', 'addify-attribute-price-markup-discount' ); ?>
						</h3>
					</div>
				</th>
				<td>
					<select  name="select_products[]" data-placeholder="Choose Products..." id="" class="ajax-products-search" multiple>
						<?php
	
						foreach ( $sel_products as $product_id ) {
							?>
							<option value="<?php echo esc_attr( $product_id ); ?>" selected >
							<?php echo esc_attr( get_the_title( intval( $product_id ) ) ); ?>
							</option>
							<?php
						}
						?>
					</select>
					<p><?php echo esc_html__( 'Leave empty for apply on all products ', 'addify-attribute-price-markup-discount' ); ?></p>
				</td>
			</tr>
			<tr class="addify-option-field enable_field" style="border-bottom: none;">
				<th>
					<div class="option-head">
						<h3>
							<?php echo esc_html__( 'Select Categories', 'addify-attribute-price-markup-discount' ); ?>
						</h3>
					</div>
				</th>
				<td>
				<div class="">
				<select name="select_pro_cat[]" id="" data-placeholder="Choose Categories..." class="select_pro_cat" multiple >
						<?php foreach ( $product_cat as $category ) : ?>
							<option value="<?php echo intval( $category->term_id ); ?>" 
							<?php echo in_array( (string) $category->term_id, $sel_cat, true ) ? 'selected' : ''; ?>
							>
							<?php echo esc_html( $category->name ); ?>
							</option>
						<?php endforeach; ?>
					</select>
				</div>
				</td>
			</tr>
	</table>
</div>
